local AddonName, GGL = ...
local GUI = GGL.GUI
local Sets = GGL.Options.Sets
local Global = {}
GGL.Options.SourceFilter = Global

local L = GGL.Locale

-- lua
local ipairs = ipairs

-- WoW

-- Libs
local AceGUI = LibStub("AceGUI-3.0")

-- ##################
-- local
-- ##################
local Helper

local LOOT_SOURCE_TYPES = GGL.LOOT_SOURCE_TYPES
local SUB_SOURCE_FLAG, SUB_SOURCE_FLAG_ICONS = GGL.SUB_SOURCE_FLAG, GGL.SUB_SOURCE_FLAG_ICONS

local CheckBoxList = {
    { LOOT_SOURCE_TYPES.mobs.id,                648206,     L["Mob loot"], },
    { LOOT_SOURCE_TYPES.lockbox.id,             134344,     L["Lockboxes"], },
    { LOOT_SOURCE_TYPES.chest.id,               SUB_SOURCE_FLAG_ICONS[SUB_SOURCE_FLAG.OPENING],         L["Chests"], },
    { LOOT_SOURCE_TYPES.disenchanting.id,       SUB_SOURCE_FLAG_ICONS[SUB_SOURCE_FLAG.DISENCHANTING],   L["Disenchanting"], },
    { LOOT_SOURCE_TYPES.fishing.id,             SUB_SOURCE_FLAG_ICONS[SUB_SOURCE_FLAG.FISHING],         L["Fishing"], },
    { LOOT_SOURCE_TYPES.herbalism.id,           SUB_SOURCE_FLAG_ICONS[SUB_SOURCE_FLAG.HERBALISM],       L["Herbalism"], },
    { LOOT_SOURCE_TYPES.mining.id,              SUB_SOURCE_FLAG_ICONS[SUB_SOURCE_FLAG.MINING],          L["Mining"], },
    { LOOT_SOURCE_TYPES.skinning.id,            SUB_SOURCE_FLAG_ICONS[SUB_SOURCE_FLAG.SKINNING],        L["Skinning"], },
    { LOOT_SOURCE_TYPES.pickpocket.id,          SUB_SOURCE_FLAG_ICONS[SUB_SOURCE_FLAG.PICK_POCKET],     L["Pick Pocket"], },
    { LOOT_SOURCE_TYPES.scrapping.id,           SUB_SOURCE_FLAG_ICONS[SUB_SOURCE_FLAG.SCRAPPING],       L["Scrapping"], },

}

-- ##################
-- local helper
-- ##################
local function SourceCheck_OnValueChanged(self, event, state)
    local sourceID = self:GetUserData("id")
    if state then
        Helper.Data["selectedDB"][sourceID] = nil
    else
        Helper.Data["selectedDB"][sourceID] = true
    end
    Helper:SaveDB()
    -- Helper:RefreshSelectedTab()
end

local function SetOnTabGroupConfigSelected(content, db, tabID)
    local base = AceGUI:Create("SimpleGroup")
    base:SetFullWidth(true)
    base:SetLayout("List")

    -- Soulbound

    for index, source in ipairs(CheckBoxList) do
        local check = AceGUI:Create("CheckBox")
        check:SetLabel(source[3])
        check:SetImage(source[2])
        check:SetValue(not db[source[1]])
        check:SetCallback("OnValueChanged", SourceCheck_OnValueChanged)
        check:SetUserData("id", source[1])
        base:AddChild(check)
    end


    content:AddChild(base)
end

-- ##################
-- options
-- ##################

local function Options(AceGUI, container)
    Helper = Sets:GetBaseGroup(container, GGL.SET_ID_LIST.LootSource)

    -- empty for now
    local tabs = {}

    --Helper:SetOnTabGroupSelected(SetOnTabGroupSelected)
    Helper:SetOnTabGroupConfigSelected(SetOnTabGroupConfigSelected)

    Helper:SetTabGroupContent(tabs, true)
end

-- Add into Options
GGL.Options:AddIntoTree(Options, L["Loot Source"], "sets_sourcefilter", "sets")